#ifndef LAYER_H
#define LAYER_H

#include "quaternion.h"
#include "vector.h"
#include <wx/dynarray.h>
#include <wx/string.h>
class Layer;
class World;
class NawiGLCanvas;

WX_DEFINE_ARRAY(Layer*, LayerArray);

class Layer
{
public:
	bool isInitialized;

	Layer *parentLayer;
	LayerArray children;
	bool updatedSinceLastRender;

	Vector position;
	Quaternion orientation;
	
	wxString name;
	wxString description;

	bool isOn;

	Layer(const wxString &name, Layer *parentLayer = NULL);
	Layer(const wxString &name, const Vector &position, const Quaternion &orientation, Layer *parentLayer = NULL);
public:	
	virtual void initialize();
	virtual void update();
	virtual void render(NawiGLCanvas *glCanvas);
	void renderChildren(NawiGLCanvas *glCanvas);
	void flagUpdatedLayers();

	virtual ~Layer();
};
#endif //LAYER_H
