#include "nawiapp.h"
#include "nawiframe.h"
#include "exception.h"
#include "downloadmanager.h"
#include <wx/stdpaths.h>
#include <wx/image.h>
#include <wx/filename.h>
#include <wx/log.h>

IMPLEMENT_APP(NawiApp)

FILE *logFile = NULL;

bool NawiApp::OnInit()
{
	SetVendorName( wxT("Nawi Project") );
	SetAppName( wxT("Nawi") );

#ifdef WIN32
	logFile = fopen("nawilog.txt", "a");
#endif
	wxLog::SetActiveTarget( new wxLogStderr(logFile) );

	if( !wxApp::OnInit() )
		return false;

	try
	{
		wxImage::AddHandler( new wxJPEGHandler );
		NawiFrame::directoryPath = wxStandardPaths::Get().GetUserDataDir();
		NawiFrame::configPath.Prepend( NawiFrame::directoryPath + wxFileName::GetPathSeparator() );
		NawiFrame::cachePath.Prepend( NawiFrame::directoryPath + wxFileName::GetPathSeparator() );
		NawiFrame::downloadManager = new DownloadManager();
		SetTopWindow( new NawiFrame(this) );
	}
	catch( Exception &e )
	{
		e.log();
	}
	return true;
}
